org.eclipse.aether

## Interface RepositorySystemSession

- All Known Implementing Classes:
    AbstractForwardingRepositorySystemSession, DefaultRepositorySystemSession

      public interface RepositorySystemSession

  Defines settings and components that control the repository system. Once initialized, the session object itself is supposed to be immutable and hence can safely be shared across an entire application and any concurrent threads reading it. Components that wish to tweak some aspects of an existing session should use the copy constructor of `DefaultRepositorySystemSession` and its mutators to derive a custom session.
  Restriction:
    This interface is not intended to be extended by clients.
  Restriction:
    This interface is not intended to be implemented by clients.

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `ArtifactDescriptorPolicy` | `getArtifactDescriptorPolicy()` Gets the policy which controls how errors related to reading artifact descriptors should be handled.
    `ArtifactTypeRegistry` | `getArtifactTypeRegistry()` Gets the registry of artifact types recognized by this session, for instance when processing artifact descriptors.
    `AuthenticationSelector` | `getAuthenticationSelector()` Gets the authentication selector to use for repositories discovered in artifact descriptors.
    `RepositoryCache` | `getCache()` Gets the cache the repository system may use to save data for future reuse during the session.
    `String` | `getChecksumPolicy()` Gets the global checksum policy.
    `Map<String,Object>` | `getConfigProperties()` Gets the configuration properties used to tweak internal aspects of the repository system (e.g. thread pooling, connector-specific behavior, etc.)
    `SessionData` | `getData()` Gets the custom data associated with this session.
    `DependencyGraphTransformer` | `getDependencyGraphTransformer()` Gets the dependency graph transformer to use for building dependency graphs.
    `DependencyManager` | `getDependencyManager()` Gets the dependency manager to use for building dependency graphs.
    `DependencySelector` | `getDependencySelector()` Gets the dependency selector to use for building dependency graphs.
    `DependencyTraverser` | `getDependencyTraverser()` Gets the dependency traverser to use for building dependency graphs.
    `LocalRepository` | `getLocalRepository()` Gets the local repository used during this session.
    `LocalRepositoryManager` | `getLocalRepositoryManager()` Gets the local repository manager used during this session.
    `MirrorSelector` | `getMirrorSelector()` Gets the mirror selector to use for repositories discovered in artifact descriptors.
    `ProxySelector` | `getProxySelector()` Gets the proxy selector to use for repositories discovered in artifact descriptors.
    `RepositoryListener` | `getRepositoryListener()` Gets the listener being notified of actions in the repository system.
    `ResolutionErrorPolicy` | `getResolutionErrorPolicy()` Gets the policy which controls whether resolutions errors from remote repositories should be cached.
    `Map<String,String>` | `getSystemProperties()` Gets the system properties to use, e.g. for processing of artifact descriptors.
    `TransferListener` | `getTransferListener()` Gets the listener being notified of uploads/downloads by the repository system.
    `String` | `getUpdatePolicy()` Gets the global update policy.
    `Map<String,String>` | `getUserProperties()` Gets the user properties to use, e.g. for processing of artifact descriptors.
    `VersionFilter` | `getVersionFilter()` Gets the version filter to use for building dependency graphs.
    `WorkspaceReader` | `getWorkspaceReader()` Gets the workspace reader used during this session.
    `boolean` | `isIgnoreArtifactDescriptorRepositories()` Indicates whether repositories declared in artifact descriptors should be ignored during transitive dependency collection.
    `boolean` | `isOffline()` Indicates whether the repository system operates in offline mode and avoids/refuses any access to remote repositories.

- - ### Method Detail

    - #### isOffline

          boolean isOffline()

      Indicates whether the repository system operates in offline mode and avoids/refuses any access to remote repositories.
      Returns:
        `true` if the repository system is in offline mode, `false` otherwise.

    - #### isIgnoreArtifactDescriptorRepositories

          boolean isIgnoreArtifactDescriptorRepositories()

      Indicates whether repositories declared in artifact descriptors should be ignored during transitive dependency collection. If enabled, only the repositories originally provided with the collect request will be considered.
      Returns:
        `true` if additional repositories from artifact descriptors are ignored, `false` to merge those with the originally specified repositories.

    - #### getResolutionErrorPolicy

          ResolutionErrorPolicy getResolutionErrorPolicy()

      Gets the policy which controls whether resolutions errors from remote repositories should be cached.
      Returns:
        The resolution error policy for this session or `null` if resolution errors should generally not be cached.

    - #### getArtifactDescriptorPolicy

          ArtifactDescriptorPolicy getArtifactDescriptorPolicy()

      Gets the policy which controls how errors related to reading artifact descriptors should be handled.
      Returns:
        The descriptor error policy for this session or `null` if descriptor errors should generally not be tolerated.

    - #### getChecksumPolicy

          String getChecksumPolicy()

      Gets the global checksum policy. If set, the global checksum policy overrides the checksum policies of the remote repositories being used for resolution.
      Returns:
        The global checksum policy or `null`/empty if not set and the per-repository policies apply.
      See Also:
        `RepositoryPolicy.CHECKSUM_POLICY_FAIL`, `RepositoryPolicy.CHECKSUM_POLICY_IGNORE`, `RepositoryPolicy.CHECKSUM_POLICY_WARN`

    - #### getUpdatePolicy

          String getUpdatePolicy()

      Gets the global update policy. If set, the global update policy overrides the update policies of the remote repositories being used for resolution.
      Returns:
        The global update policy or `null`/empty if not set and the per-repository policies apply.
      See Also:
        `RepositoryPolicy.UPDATE_POLICY_ALWAYS`, `RepositoryPolicy.UPDATE_POLICY_DAILY`, `RepositoryPolicy.UPDATE_POLICY_NEVER`

    - #### getLocalRepository

          LocalRepository getLocalRepository()

      Gets the local repository used during this session. This is a convenience method for `LocalRepositoryManager.getRepository()`.
      Returns:
        The local repository being during this session, never `null`.

    - #### getLocalRepositoryManager

          LocalRepositoryManager getLocalRepositoryManager()

      Gets the local repository manager used during this session.
      Returns:
        The local repository manager used during this session, never `null`.

    - #### getWorkspaceReader

          WorkspaceReader getWorkspaceReader()

      Gets the workspace reader used during this session. If set, the workspace reader will usually be consulted first to resolve artifacts.
      Returns:
        The workspace reader for this session or `null` if none.

    - #### getRepositoryListener

          RepositoryListener getRepositoryListener()

      Gets the listener being notified of actions in the repository system.
      Returns:
        The repository listener or `null` if none.

    - #### getTransferListener

          TransferListener getTransferListener()

      Gets the listener being notified of uploads/downloads by the repository system.
      Returns:
        The transfer listener or `null` if none.

    - #### getSystemProperties

          Map<String,String> getSystemProperties()

      Gets the system properties to use, e.g. for processing of artifact descriptors. System properties are usually collected from the runtime environment like `System.getProperties()` and environment variables.
      Returns:
        The (read-only) system properties, never `null`.

    - #### getUserProperties

          Map<String,String> getUserProperties()

      Gets the user properties to use, e.g. for processing of artifact descriptors. User properties are similar to system properties but are set on the discretion of the user and hence are considered of higher priority than system properties.
      Returns:
        The (read-only) user properties, never `null`.

    - #### getConfigProperties

          Map<String,Object> getConfigProperties()

      Gets the configuration properties used to tweak internal aspects of the repository system (e.g. thread pooling, connector-specific behavior, etc.)
      Returns:
        The (read-only) configuration properties, never `null`.
      See Also:
        `ConfigurationProperties`

    - #### getMirrorSelector

          MirrorSelector getMirrorSelector()

      Gets the mirror selector to use for repositories discovered in artifact descriptors. Note that this selector is not used for remote repositories which are passed as request parameters to the repository system, those repositories are supposed to denote the effective repositories.
      Returns:
        The mirror selector to use, never `null`.
      See Also:
        `RepositorySystem.newResolutionRepositories(RepositorySystemSession, java.util.List)`

    - #### getProxySelector

          ProxySelector getProxySelector()

      Gets the proxy selector to use for repositories discovered in artifact descriptors. Note that this selector is not used for remote repositories which are passed as request parameters to the repository system, those repositories are supposed to have their proxy (if any) already set.
      Returns:
        The proxy selector to use, never `null`.
      See Also:
        `RemoteRepository.getProxy()`, `RepositorySystem.newResolutionRepositories(RepositorySystemSession, java.util.List)`

    - #### getAuthenticationSelector

          AuthenticationSelector getAuthenticationSelector()

      Gets the authentication selector to use for repositories discovered in artifact descriptors. Note that this selector is not used for remote repositories which are passed as request parameters to the repository system, those repositories are supposed to have their authentication (if any) already set.
      Returns:
        The authentication selector to use, never `null`.
      See Also:
        `RemoteRepository.getAuthentication()`, `RepositorySystem.newResolutionRepositories(RepositorySystemSession, java.util.List)`

    - #### getArtifactTypeRegistry

          ArtifactTypeRegistry getArtifactTypeRegistry()

      Gets the registry of artifact types recognized by this session, for instance when processing artifact descriptors.
      Returns:
        The artifact type registry, never `null`.

    - #### getDependencyTraverser

          DependencyTraverser getDependencyTraverser()

      Gets the dependency traverser to use for building dependency graphs.
      Returns:
        The dependency traverser to use for building dependency graphs or `null` if dependencies are unconditionally traversed.

    - #### getDependencyManager

          DependencyManager getDependencyManager()

      Gets the dependency manager to use for building dependency graphs.
      Returns:
        The dependency manager to use for building dependency graphs or `null` if dependency management is not performed.

    - #### getDependencySelector

          DependencySelector getDependencySelector()

      Gets the dependency selector to use for building dependency graphs.
      Returns:
        The dependency selector to use for building dependency graphs or `null` if dependencies are unconditionally included.

    - #### getVersionFilter

          VersionFilter getVersionFilter()

      Gets the version filter to use for building dependency graphs.
      Returns:
        The version filter to use for building dependency graphs or `null` if versions aren't filtered.

    - #### getDependencyGraphTransformer

          DependencyGraphTransformer getDependencyGraphTransformer()

      Gets the dependency graph transformer to use for building dependency graphs.
      Returns:
        The dependency graph transformer to use for building dependency graphs or `null` if none.

    - #### getData

          SessionData getData()

      Gets the custom data associated with this session.
      Returns:
        The session data, never `null`.

    - #### getCache

          RepositoryCache getCache()

      Gets the cache the repository system may use to save data for future reuse during the session.
      Returns:
        The repository cache or `null` if none.

Copyright © 2010-2014 The Eclipse Foundation. All Rights Reserved.